/*
Nexodus API

This is the Nexodus API Server.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package client

import (
	"encoding/json"
)

// checks if the ModelsDevice type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ModelsDevice{}

// ModelsDevice struct for ModelsDevice
type ModelsDevice struct {
	AdvertiseCidrs []string `json:"advertise_cidrs,omitempty"`
	AllowedIps     []string `json:"allowed_ips,omitempty"`
	// the token nexd should use to reconcile device state.
	BearerToken     *string          `json:"bearer_token,omitempty"`
	Endpoints       []ModelsEndpoint `json:"endpoints,omitempty"`
	Hostname        *string          `json:"hostname,omitempty"`
	Id              *string          `json:"id,omitempty"`
	Ipv4TunnelIps   []ModelsTunnelIP `json:"ipv4_tunnel_ips,omitempty"`
	Ipv6TunnelIps   []ModelsTunnelIP `json:"ipv6_tunnel_ips,omitempty"`
	Online          *bool            `json:"online,omitempty"`
	OnlineAt        *string          `json:"online_at,omitempty"`
	Os              *string          `json:"os,omitempty"`
	OwnerId         *string          `json:"owner_id,omitempty"`
	PublicKey       *string          `json:"public_key,omitempty"`
	Relay           *bool            `json:"relay,omitempty"`
	Revision        *int32           `json:"revision,omitempty"`
	SecurityGroupId *string          `json:"security_group_id,omitempty"`
	SymmetricNat    *bool            `json:"symmetric_nat,omitempty"`
	VpcId           *string          `json:"vpc_id,omitempty"`
}

// NewModelsDevice instantiates a new ModelsDevice object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewModelsDevice() *ModelsDevice {
	this := ModelsDevice{}
	return &this
}

// NewModelsDeviceWithDefaults instantiates a new ModelsDevice object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewModelsDeviceWithDefaults() *ModelsDevice {
	this := ModelsDevice{}
	return &this
}

// GetAdvertiseCidrs returns the AdvertiseCidrs field value if set, zero value otherwise.
func (o *ModelsDevice) GetAdvertiseCidrs() []string {
	if o == nil || IsNil(o.AdvertiseCidrs) {
		var ret []string
		return ret
	}
	return o.AdvertiseCidrs
}

// GetAdvertiseCidrsOk returns a tuple with the AdvertiseCidrs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetAdvertiseCidrsOk() ([]string, bool) {
	if o == nil || IsNil(o.AdvertiseCidrs) {
		return nil, false
	}
	return o.AdvertiseCidrs, true
}

// HasAdvertiseCidrs returns a boolean if a field has been set.
func (o *ModelsDevice) HasAdvertiseCidrs() bool {
	if o != nil && !IsNil(o.AdvertiseCidrs) {
		return true
	}

	return false
}

// SetAdvertiseCidrs gets a reference to the given []string and assigns it to the AdvertiseCidrs field.
func (o *ModelsDevice) SetAdvertiseCidrs(v []string) {
	o.AdvertiseCidrs = v
}

// GetAllowedIps returns the AllowedIps field value if set, zero value otherwise.
func (o *ModelsDevice) GetAllowedIps() []string {
	if o == nil || IsNil(o.AllowedIps) {
		var ret []string
		return ret
	}
	return o.AllowedIps
}

// GetAllowedIpsOk returns a tuple with the AllowedIps field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetAllowedIpsOk() ([]string, bool) {
	if o == nil || IsNil(o.AllowedIps) {
		return nil, false
	}
	return o.AllowedIps, true
}

// HasAllowedIps returns a boolean if a field has been set.
func (o *ModelsDevice) HasAllowedIps() bool {
	if o != nil && !IsNil(o.AllowedIps) {
		return true
	}

	return false
}

// SetAllowedIps gets a reference to the given []string and assigns it to the AllowedIps field.
func (o *ModelsDevice) SetAllowedIps(v []string) {
	o.AllowedIps = v
}

// GetBearerToken returns the BearerToken field value if set, zero value otherwise.
func (o *ModelsDevice) GetBearerToken() string {
	if o == nil || IsNil(o.BearerToken) {
		var ret string
		return ret
	}
	return *o.BearerToken
}

// GetBearerTokenOk returns a tuple with the BearerToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetBearerTokenOk() (*string, bool) {
	if o == nil || IsNil(o.BearerToken) {
		return nil, false
	}
	return o.BearerToken, true
}

// HasBearerToken returns a boolean if a field has been set.
func (o *ModelsDevice) HasBearerToken() bool {
	if o != nil && !IsNil(o.BearerToken) {
		return true
	}

	return false
}

// SetBearerToken gets a reference to the given string and assigns it to the BearerToken field.
func (o *ModelsDevice) SetBearerToken(v string) {
	o.BearerToken = &v
}

// GetEndpoints returns the Endpoints field value if set, zero value otherwise.
func (o *ModelsDevice) GetEndpoints() []ModelsEndpoint {
	if o == nil || IsNil(o.Endpoints) {
		var ret []ModelsEndpoint
		return ret
	}
	return o.Endpoints
}

// GetEndpointsOk returns a tuple with the Endpoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetEndpointsOk() ([]ModelsEndpoint, bool) {
	if o == nil || IsNil(o.Endpoints) {
		return nil, false
	}
	return o.Endpoints, true
}

// HasEndpoints returns a boolean if a field has been set.
func (o *ModelsDevice) HasEndpoints() bool {
	if o != nil && !IsNil(o.Endpoints) {
		return true
	}

	return false
}

// SetEndpoints gets a reference to the given []ModelsEndpoint and assigns it to the Endpoints field.
func (o *ModelsDevice) SetEndpoints(v []ModelsEndpoint) {
	o.Endpoints = v
}

// GetHostname returns the Hostname field value if set, zero value otherwise.
func (o *ModelsDevice) GetHostname() string {
	if o == nil || IsNil(o.Hostname) {
		var ret string
		return ret
	}
	return *o.Hostname
}

// GetHostnameOk returns a tuple with the Hostname field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetHostnameOk() (*string, bool) {
	if o == nil || IsNil(o.Hostname) {
		return nil, false
	}
	return o.Hostname, true
}

// HasHostname returns a boolean if a field has been set.
func (o *ModelsDevice) HasHostname() bool {
	if o != nil && !IsNil(o.Hostname) {
		return true
	}

	return false
}

// SetHostname gets a reference to the given string and assigns it to the Hostname field.
func (o *ModelsDevice) SetHostname(v string) {
	o.Hostname = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ModelsDevice) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ModelsDevice) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *ModelsDevice) SetId(v string) {
	o.Id = &v
}

// GetIpv4TunnelIps returns the Ipv4TunnelIps field value if set, zero value otherwise.
func (o *ModelsDevice) GetIpv4TunnelIps() []ModelsTunnelIP {
	if o == nil || IsNil(o.Ipv4TunnelIps) {
		var ret []ModelsTunnelIP
		return ret
	}
	return o.Ipv4TunnelIps
}

// GetIpv4TunnelIpsOk returns a tuple with the Ipv4TunnelIps field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetIpv4TunnelIpsOk() ([]ModelsTunnelIP, bool) {
	if o == nil || IsNil(o.Ipv4TunnelIps) {
		return nil, false
	}
	return o.Ipv4TunnelIps, true
}

// HasIpv4TunnelIps returns a boolean if a field has been set.
func (o *ModelsDevice) HasIpv4TunnelIps() bool {
	if o != nil && !IsNil(o.Ipv4TunnelIps) {
		return true
	}

	return false
}

// SetIpv4TunnelIps gets a reference to the given []ModelsTunnelIP and assigns it to the Ipv4TunnelIps field.
func (o *ModelsDevice) SetIpv4TunnelIps(v []ModelsTunnelIP) {
	o.Ipv4TunnelIps = v
}

// GetIpv6TunnelIps returns the Ipv6TunnelIps field value if set, zero value otherwise.
func (o *ModelsDevice) GetIpv6TunnelIps() []ModelsTunnelIP {
	if o == nil || IsNil(o.Ipv6TunnelIps) {
		var ret []ModelsTunnelIP
		return ret
	}
	return o.Ipv6TunnelIps
}

// GetIpv6TunnelIpsOk returns a tuple with the Ipv6TunnelIps field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetIpv6TunnelIpsOk() ([]ModelsTunnelIP, bool) {
	if o == nil || IsNil(o.Ipv6TunnelIps) {
		return nil, false
	}
	return o.Ipv6TunnelIps, true
}

// HasIpv6TunnelIps returns a boolean if a field has been set.
func (o *ModelsDevice) HasIpv6TunnelIps() bool {
	if o != nil && !IsNil(o.Ipv6TunnelIps) {
		return true
	}

	return false
}

// SetIpv6TunnelIps gets a reference to the given []ModelsTunnelIP and assigns it to the Ipv6TunnelIps field.
func (o *ModelsDevice) SetIpv6TunnelIps(v []ModelsTunnelIP) {
	o.Ipv6TunnelIps = v
}

// GetOnline returns the Online field value if set, zero value otherwise.
func (o *ModelsDevice) GetOnline() bool {
	if o == nil || IsNil(o.Online) {
		var ret bool
		return ret
	}
	return *o.Online
}

// GetOnlineOk returns a tuple with the Online field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetOnlineOk() (*bool, bool) {
	if o == nil || IsNil(o.Online) {
		return nil, false
	}
	return o.Online, true
}

// HasOnline returns a boolean if a field has been set.
func (o *ModelsDevice) HasOnline() bool {
	if o != nil && !IsNil(o.Online) {
		return true
	}

	return false
}

// SetOnline gets a reference to the given bool and assigns it to the Online field.
func (o *ModelsDevice) SetOnline(v bool) {
	o.Online = &v
}

// GetOnlineAt returns the OnlineAt field value if set, zero value otherwise.
func (o *ModelsDevice) GetOnlineAt() string {
	if o == nil || IsNil(o.OnlineAt) {
		var ret string
		return ret
	}
	return *o.OnlineAt
}

// GetOnlineAtOk returns a tuple with the OnlineAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetOnlineAtOk() (*string, bool) {
	if o == nil || IsNil(o.OnlineAt) {
		return nil, false
	}
	return o.OnlineAt, true
}

// HasOnlineAt returns a boolean if a field has been set.
func (o *ModelsDevice) HasOnlineAt() bool {
	if o != nil && !IsNil(o.OnlineAt) {
		return true
	}

	return false
}

// SetOnlineAt gets a reference to the given string and assigns it to the OnlineAt field.
func (o *ModelsDevice) SetOnlineAt(v string) {
	o.OnlineAt = &v
}

// GetOs returns the Os field value if set, zero value otherwise.
func (o *ModelsDevice) GetOs() string {
	if o == nil || IsNil(o.Os) {
		var ret string
		return ret
	}
	return *o.Os
}

// GetOsOk returns a tuple with the Os field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetOsOk() (*string, bool) {
	if o == nil || IsNil(o.Os) {
		return nil, false
	}
	return o.Os, true
}

// HasOs returns a boolean if a field has been set.
func (o *ModelsDevice) HasOs() bool {
	if o != nil && !IsNil(o.Os) {
		return true
	}

	return false
}

// SetOs gets a reference to the given string and assigns it to the Os field.
func (o *ModelsDevice) SetOs(v string) {
	o.Os = &v
}

// GetOwnerId returns the OwnerId field value if set, zero value otherwise.
func (o *ModelsDevice) GetOwnerId() string {
	if o == nil || IsNil(o.OwnerId) {
		var ret string
		return ret
	}
	return *o.OwnerId
}

// GetOwnerIdOk returns a tuple with the OwnerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetOwnerIdOk() (*string, bool) {
	if o == nil || IsNil(o.OwnerId) {
		return nil, false
	}
	return o.OwnerId, true
}

// HasOwnerId returns a boolean if a field has been set.
func (o *ModelsDevice) HasOwnerId() bool {
	if o != nil && !IsNil(o.OwnerId) {
		return true
	}

	return false
}

// SetOwnerId gets a reference to the given string and assigns it to the OwnerId field.
func (o *ModelsDevice) SetOwnerId(v string) {
	o.OwnerId = &v
}

// GetPublicKey returns the PublicKey field value if set, zero value otherwise.
func (o *ModelsDevice) GetPublicKey() string {
	if o == nil || IsNil(o.PublicKey) {
		var ret string
		return ret
	}
	return *o.PublicKey
}

// GetPublicKeyOk returns a tuple with the PublicKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetPublicKeyOk() (*string, bool) {
	if o == nil || IsNil(o.PublicKey) {
		return nil, false
	}
	return o.PublicKey, true
}

// HasPublicKey returns a boolean if a field has been set.
func (o *ModelsDevice) HasPublicKey() bool {
	if o != nil && !IsNil(o.PublicKey) {
		return true
	}

	return false
}

// SetPublicKey gets a reference to the given string and assigns it to the PublicKey field.
func (o *ModelsDevice) SetPublicKey(v string) {
	o.PublicKey = &v
}

// GetRelay returns the Relay field value if set, zero value otherwise.
func (o *ModelsDevice) GetRelay() bool {
	if o == nil || IsNil(o.Relay) {
		var ret bool
		return ret
	}
	return *o.Relay
}

// GetRelayOk returns a tuple with the Relay field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetRelayOk() (*bool, bool) {
	if o == nil || IsNil(o.Relay) {
		return nil, false
	}
	return o.Relay, true
}

// HasRelay returns a boolean if a field has been set.
func (o *ModelsDevice) HasRelay() bool {
	if o != nil && !IsNil(o.Relay) {
		return true
	}

	return false
}

// SetRelay gets a reference to the given bool and assigns it to the Relay field.
func (o *ModelsDevice) SetRelay(v bool) {
	o.Relay = &v
}

// GetRevision returns the Revision field value if set, zero value otherwise.
func (o *ModelsDevice) GetRevision() int32 {
	if o == nil || IsNil(o.Revision) {
		var ret int32
		return ret
	}
	return *o.Revision
}

// GetRevisionOk returns a tuple with the Revision field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetRevisionOk() (*int32, bool) {
	if o == nil || IsNil(o.Revision) {
		return nil, false
	}
	return o.Revision, true
}

// HasRevision returns a boolean if a field has been set.
func (o *ModelsDevice) HasRevision() bool {
	if o != nil && !IsNil(o.Revision) {
		return true
	}

	return false
}

// SetRevision gets a reference to the given int32 and assigns it to the Revision field.
func (o *ModelsDevice) SetRevision(v int32) {
	o.Revision = &v
}

// GetSecurityGroupId returns the SecurityGroupId field value if set, zero value otherwise.
func (o *ModelsDevice) GetSecurityGroupId() string {
	if o == nil || IsNil(o.SecurityGroupId) {
		var ret string
		return ret
	}
	return *o.SecurityGroupId
}

// GetSecurityGroupIdOk returns a tuple with the SecurityGroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetSecurityGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.SecurityGroupId) {
		return nil, false
	}
	return o.SecurityGroupId, true
}

// HasSecurityGroupId returns a boolean if a field has been set.
func (o *ModelsDevice) HasSecurityGroupId() bool {
	if o != nil && !IsNil(o.SecurityGroupId) {
		return true
	}

	return false
}

// SetSecurityGroupId gets a reference to the given string and assigns it to the SecurityGroupId field.
func (o *ModelsDevice) SetSecurityGroupId(v string) {
	o.SecurityGroupId = &v
}

// GetSymmetricNat returns the SymmetricNat field value if set, zero value otherwise.
func (o *ModelsDevice) GetSymmetricNat() bool {
	if o == nil || IsNil(o.SymmetricNat) {
		var ret bool
		return ret
	}
	return *o.SymmetricNat
}

// GetSymmetricNatOk returns a tuple with the SymmetricNat field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetSymmetricNatOk() (*bool, bool) {
	if o == nil || IsNil(o.SymmetricNat) {
		return nil, false
	}
	return o.SymmetricNat, true
}

// HasSymmetricNat returns a boolean if a field has been set.
func (o *ModelsDevice) HasSymmetricNat() bool {
	if o != nil && !IsNil(o.SymmetricNat) {
		return true
	}

	return false
}

// SetSymmetricNat gets a reference to the given bool and assigns it to the SymmetricNat field.
func (o *ModelsDevice) SetSymmetricNat(v bool) {
	o.SymmetricNat = &v
}

// GetVpcId returns the VpcId field value if set, zero value otherwise.
func (o *ModelsDevice) GetVpcId() string {
	if o == nil || IsNil(o.VpcId) {
		var ret string
		return ret
	}
	return *o.VpcId
}

// GetVpcIdOk returns a tuple with the VpcId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsDevice) GetVpcIdOk() (*string, bool) {
	if o == nil || IsNil(o.VpcId) {
		return nil, false
	}
	return o.VpcId, true
}

// HasVpcId returns a boolean if a field has been set.
func (o *ModelsDevice) HasVpcId() bool {
	if o != nil && !IsNil(o.VpcId) {
		return true
	}

	return false
}

// SetVpcId gets a reference to the given string and assigns it to the VpcId field.
func (o *ModelsDevice) SetVpcId(v string) {
	o.VpcId = &v
}

func (o ModelsDevice) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ModelsDevice) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AdvertiseCidrs) {
		toSerialize["advertise_cidrs"] = o.AdvertiseCidrs
	}
	if !IsNil(o.AllowedIps) {
		toSerialize["allowed_ips"] = o.AllowedIps
	}
	if !IsNil(o.BearerToken) {
		toSerialize["bearer_token"] = o.BearerToken
	}
	if !IsNil(o.Endpoints) {
		toSerialize["endpoints"] = o.Endpoints
	}
	if !IsNil(o.Hostname) {
		toSerialize["hostname"] = o.Hostname
	}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Ipv4TunnelIps) {
		toSerialize["ipv4_tunnel_ips"] = o.Ipv4TunnelIps
	}
	if !IsNil(o.Ipv6TunnelIps) {
		toSerialize["ipv6_tunnel_ips"] = o.Ipv6TunnelIps
	}
	if !IsNil(o.Online) {
		toSerialize["online"] = o.Online
	}
	if !IsNil(o.OnlineAt) {
		toSerialize["online_at"] = o.OnlineAt
	}
	if !IsNil(o.Os) {
		toSerialize["os"] = o.Os
	}
	if !IsNil(o.OwnerId) {
		toSerialize["owner_id"] = o.OwnerId
	}
	if !IsNil(o.PublicKey) {
		toSerialize["public_key"] = o.PublicKey
	}
	if !IsNil(o.Relay) {
		toSerialize["relay"] = o.Relay
	}
	if !IsNil(o.Revision) {
		toSerialize["revision"] = o.Revision
	}
	if !IsNil(o.SecurityGroupId) {
		toSerialize["security_group_id"] = o.SecurityGroupId
	}
	if !IsNil(o.SymmetricNat) {
		toSerialize["symmetric_nat"] = o.SymmetricNat
	}
	if !IsNil(o.VpcId) {
		toSerialize["vpc_id"] = o.VpcId
	}
	return toSerialize, nil
}

type NullableModelsDevice struct {
	value *ModelsDevice
	isSet bool
}

func (v NullableModelsDevice) Get() *ModelsDevice {
	return v.value
}

func (v *NullableModelsDevice) Set(val *ModelsDevice) {
	v.value = val
	v.isSet = true
}

func (v NullableModelsDevice) IsSet() bool {
	return v.isSet
}

func (v *NullableModelsDevice) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableModelsDevice(val *ModelsDevice) *NullableModelsDevice {
	return &NullableModelsDevice{value: val, isSet: true}
}

func (v NullableModelsDevice) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableModelsDevice) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
