/*
Nexodus API

This is the Nexodus API Server.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package client

import (
	"encoding/json"
)

// checks if the ModelsEndpoint type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ModelsEndpoint{}

// ModelsEndpoint struct for ModelsEndpoint
type ModelsEndpoint struct {
	// IP address and port of the endpoint.
	Address *string `json:"address,omitempty"`
	// How the endpoint was discovered
	Source *string `json:"source,omitempty"`
}

// NewModelsEndpoint instantiates a new ModelsEndpoint object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewModelsEndpoint() *ModelsEndpoint {
	this := ModelsEndpoint{}
	return &this
}

// NewModelsEndpointWithDefaults instantiates a new ModelsEndpoint object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewModelsEndpointWithDefaults() *ModelsEndpoint {
	this := ModelsEndpoint{}
	return &this
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *ModelsEndpoint) GetAddress() string {
	if o == nil || IsNil(o.Address) {
		var ret string
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsEndpoint) GetAddressOk() (*string, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *ModelsEndpoint) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given string and assigns it to the Address field.
func (o *ModelsEndpoint) SetAddress(v string) {
	o.Address = &v
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *ModelsEndpoint) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsEndpoint) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *ModelsEndpoint) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *ModelsEndpoint) SetSource(v string) {
	o.Source = &v
}

func (o ModelsEndpoint) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ModelsEndpoint) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	return toSerialize, nil
}

type NullableModelsEndpoint struct {
	value *ModelsEndpoint
	isSet bool
}

func (v NullableModelsEndpoint) Get() *ModelsEndpoint {
	return v.value
}

func (v *NullableModelsEndpoint) Set(val *ModelsEndpoint) {
	v.value = val
	v.isSet = true
}

func (v NullableModelsEndpoint) IsSet() bool {
	return v.isSet
}

func (v *NullableModelsEndpoint) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableModelsEndpoint(val *ModelsEndpoint) *NullableModelsEndpoint {
	return &NullableModelsEndpoint{value: val, isSet: true}
}

func (v NullableModelsEndpoint) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableModelsEndpoint) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
