/*
Nexodus API

This is the Nexodus API Server.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package client

import (
	"encoding/json"
)

// checks if the ModelsSite type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ModelsSite{}

// ModelsSite struct for ModelsSite
type ModelsSite struct {
	// the token nexd should use to reconcile Site state.
	BearerToken      *string `json:"bearer_token,omitempty"`
	Hostname         *string `json:"hostname,omitempty"`
	Id               *string `json:"id,omitempty"`
	LinkSecret       *string `json:"link_secret,omitempty"`
	Name             *string `json:"name,omitempty"`
	Online           *bool   `json:"online,omitempty"`
	OnlineAt         *string `json:"online_at,omitempty"`
	Os               *string `json:"os,omitempty"`
	OwnerId          *string `json:"owner_id,omitempty"`
	Platform         *string `json:"platform,omitempty"`
	PublicKey        *string `json:"public_key,omitempty"`
	Revision         *int32  `json:"revision,omitempty"`
	ServiceNetworkId *string `json:"service_network_id,omitempty"`
}

// NewModelsSite instantiates a new ModelsSite object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewModelsSite() *ModelsSite {
	this := ModelsSite{}
	return &this
}

// NewModelsSiteWithDefaults instantiates a new ModelsSite object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewModelsSiteWithDefaults() *ModelsSite {
	this := ModelsSite{}
	return &this
}

// GetBearerToken returns the BearerToken field value if set, zero value otherwise.
func (o *ModelsSite) GetBearerToken() string {
	if o == nil || IsNil(o.BearerToken) {
		var ret string
		return ret
	}
	return *o.BearerToken
}

// GetBearerTokenOk returns a tuple with the BearerToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetBearerTokenOk() (*string, bool) {
	if o == nil || IsNil(o.BearerToken) {
		return nil, false
	}
	return o.BearerToken, true
}

// HasBearerToken returns a boolean if a field has been set.
func (o *ModelsSite) HasBearerToken() bool {
	if o != nil && !IsNil(o.BearerToken) {
		return true
	}

	return false
}

// SetBearerToken gets a reference to the given string and assigns it to the BearerToken field.
func (o *ModelsSite) SetBearerToken(v string) {
	o.BearerToken = &v
}

// GetHostname returns the Hostname field value if set, zero value otherwise.
func (o *ModelsSite) GetHostname() string {
	if o == nil || IsNil(o.Hostname) {
		var ret string
		return ret
	}
	return *o.Hostname
}

// GetHostnameOk returns a tuple with the Hostname field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetHostnameOk() (*string, bool) {
	if o == nil || IsNil(o.Hostname) {
		return nil, false
	}
	return o.Hostname, true
}

// HasHostname returns a boolean if a field has been set.
func (o *ModelsSite) HasHostname() bool {
	if o != nil && !IsNil(o.Hostname) {
		return true
	}

	return false
}

// SetHostname gets a reference to the given string and assigns it to the Hostname field.
func (o *ModelsSite) SetHostname(v string) {
	o.Hostname = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ModelsSite) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ModelsSite) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *ModelsSite) SetId(v string) {
	o.Id = &v
}

// GetLinkSecret returns the LinkSecret field value if set, zero value otherwise.
func (o *ModelsSite) GetLinkSecret() string {
	if o == nil || IsNil(o.LinkSecret) {
		var ret string
		return ret
	}
	return *o.LinkSecret
}

// GetLinkSecretOk returns a tuple with the LinkSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetLinkSecretOk() (*string, bool) {
	if o == nil || IsNil(o.LinkSecret) {
		return nil, false
	}
	return o.LinkSecret, true
}

// HasLinkSecret returns a boolean if a field has been set.
func (o *ModelsSite) HasLinkSecret() bool {
	if o != nil && !IsNil(o.LinkSecret) {
		return true
	}

	return false
}

// SetLinkSecret gets a reference to the given string and assigns it to the LinkSecret field.
func (o *ModelsSite) SetLinkSecret(v string) {
	o.LinkSecret = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *ModelsSite) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *ModelsSite) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *ModelsSite) SetName(v string) {
	o.Name = &v
}

// GetOnline returns the Online field value if set, zero value otherwise.
func (o *ModelsSite) GetOnline() bool {
	if o == nil || IsNil(o.Online) {
		var ret bool
		return ret
	}
	return *o.Online
}

// GetOnlineOk returns a tuple with the Online field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetOnlineOk() (*bool, bool) {
	if o == nil || IsNil(o.Online) {
		return nil, false
	}
	return o.Online, true
}

// HasOnline returns a boolean if a field has been set.
func (o *ModelsSite) HasOnline() bool {
	if o != nil && !IsNil(o.Online) {
		return true
	}

	return false
}

// SetOnline gets a reference to the given bool and assigns it to the Online field.
func (o *ModelsSite) SetOnline(v bool) {
	o.Online = &v
}

// GetOnlineAt returns the OnlineAt field value if set, zero value otherwise.
func (o *ModelsSite) GetOnlineAt() string {
	if o == nil || IsNil(o.OnlineAt) {
		var ret string
		return ret
	}
	return *o.OnlineAt
}

// GetOnlineAtOk returns a tuple with the OnlineAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetOnlineAtOk() (*string, bool) {
	if o == nil || IsNil(o.OnlineAt) {
		return nil, false
	}
	return o.OnlineAt, true
}

// HasOnlineAt returns a boolean if a field has been set.
func (o *ModelsSite) HasOnlineAt() bool {
	if o != nil && !IsNil(o.OnlineAt) {
		return true
	}

	return false
}

// SetOnlineAt gets a reference to the given string and assigns it to the OnlineAt field.
func (o *ModelsSite) SetOnlineAt(v string) {
	o.OnlineAt = &v
}

// GetOs returns the Os field value if set, zero value otherwise.
func (o *ModelsSite) GetOs() string {
	if o == nil || IsNil(o.Os) {
		var ret string
		return ret
	}
	return *o.Os
}

// GetOsOk returns a tuple with the Os field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetOsOk() (*string, bool) {
	if o == nil || IsNil(o.Os) {
		return nil, false
	}
	return o.Os, true
}

// HasOs returns a boolean if a field has been set.
func (o *ModelsSite) HasOs() bool {
	if o != nil && !IsNil(o.Os) {
		return true
	}

	return false
}

// SetOs gets a reference to the given string and assigns it to the Os field.
func (o *ModelsSite) SetOs(v string) {
	o.Os = &v
}

// GetOwnerId returns the OwnerId field value if set, zero value otherwise.
func (o *ModelsSite) GetOwnerId() string {
	if o == nil || IsNil(o.OwnerId) {
		var ret string
		return ret
	}
	return *o.OwnerId
}

// GetOwnerIdOk returns a tuple with the OwnerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetOwnerIdOk() (*string, bool) {
	if o == nil || IsNil(o.OwnerId) {
		return nil, false
	}
	return o.OwnerId, true
}

// HasOwnerId returns a boolean if a field has been set.
func (o *ModelsSite) HasOwnerId() bool {
	if o != nil && !IsNil(o.OwnerId) {
		return true
	}

	return false
}

// SetOwnerId gets a reference to the given string and assigns it to the OwnerId field.
func (o *ModelsSite) SetOwnerId(v string) {
	o.OwnerId = &v
}

// GetPlatform returns the Platform field value if set, zero value otherwise.
func (o *ModelsSite) GetPlatform() string {
	if o == nil || IsNil(o.Platform) {
		var ret string
		return ret
	}
	return *o.Platform
}

// GetPlatformOk returns a tuple with the Platform field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetPlatformOk() (*string, bool) {
	if o == nil || IsNil(o.Platform) {
		return nil, false
	}
	return o.Platform, true
}

// HasPlatform returns a boolean if a field has been set.
func (o *ModelsSite) HasPlatform() bool {
	if o != nil && !IsNil(o.Platform) {
		return true
	}

	return false
}

// SetPlatform gets a reference to the given string and assigns it to the Platform field.
func (o *ModelsSite) SetPlatform(v string) {
	o.Platform = &v
}

// GetPublicKey returns the PublicKey field value if set, zero value otherwise.
func (o *ModelsSite) GetPublicKey() string {
	if o == nil || IsNil(o.PublicKey) {
		var ret string
		return ret
	}
	return *o.PublicKey
}

// GetPublicKeyOk returns a tuple with the PublicKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetPublicKeyOk() (*string, bool) {
	if o == nil || IsNil(o.PublicKey) {
		return nil, false
	}
	return o.PublicKey, true
}

// HasPublicKey returns a boolean if a field has been set.
func (o *ModelsSite) HasPublicKey() bool {
	if o != nil && !IsNil(o.PublicKey) {
		return true
	}

	return false
}

// SetPublicKey gets a reference to the given string and assigns it to the PublicKey field.
func (o *ModelsSite) SetPublicKey(v string) {
	o.PublicKey = &v
}

// GetRevision returns the Revision field value if set, zero value otherwise.
func (o *ModelsSite) GetRevision() int32 {
	if o == nil || IsNil(o.Revision) {
		var ret int32
		return ret
	}
	return *o.Revision
}

// GetRevisionOk returns a tuple with the Revision field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetRevisionOk() (*int32, bool) {
	if o == nil || IsNil(o.Revision) {
		return nil, false
	}
	return o.Revision, true
}

// HasRevision returns a boolean if a field has been set.
func (o *ModelsSite) HasRevision() bool {
	if o != nil && !IsNil(o.Revision) {
		return true
	}

	return false
}

// SetRevision gets a reference to the given int32 and assigns it to the Revision field.
func (o *ModelsSite) SetRevision(v int32) {
	o.Revision = &v
}

// GetServiceNetworkId returns the ServiceNetworkId field value if set, zero value otherwise.
func (o *ModelsSite) GetServiceNetworkId() string {
	if o == nil || IsNil(o.ServiceNetworkId) {
		var ret string
		return ret
	}
	return *o.ServiceNetworkId
}

// GetServiceNetworkIdOk returns a tuple with the ServiceNetworkId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsSite) GetServiceNetworkIdOk() (*string, bool) {
	if o == nil || IsNil(o.ServiceNetworkId) {
		return nil, false
	}
	return o.ServiceNetworkId, true
}

// HasServiceNetworkId returns a boolean if a field has been set.
func (o *ModelsSite) HasServiceNetworkId() bool {
	if o != nil && !IsNil(o.ServiceNetworkId) {
		return true
	}

	return false
}

// SetServiceNetworkId gets a reference to the given string and assigns it to the ServiceNetworkId field.
func (o *ModelsSite) SetServiceNetworkId(v string) {
	o.ServiceNetworkId = &v
}

func (o ModelsSite) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ModelsSite) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.BearerToken) {
		toSerialize["bearer_token"] = o.BearerToken
	}
	if !IsNil(o.Hostname) {
		toSerialize["hostname"] = o.Hostname
	}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.LinkSecret) {
		toSerialize["link_secret"] = o.LinkSecret
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Online) {
		toSerialize["online"] = o.Online
	}
	if !IsNil(o.OnlineAt) {
		toSerialize["online_at"] = o.OnlineAt
	}
	if !IsNil(o.Os) {
		toSerialize["os"] = o.Os
	}
	if !IsNil(o.OwnerId) {
		toSerialize["owner_id"] = o.OwnerId
	}
	if !IsNil(o.Platform) {
		toSerialize["platform"] = o.Platform
	}
	if !IsNil(o.PublicKey) {
		toSerialize["public_key"] = o.PublicKey
	}
	if !IsNil(o.Revision) {
		toSerialize["revision"] = o.Revision
	}
	if !IsNil(o.ServiceNetworkId) {
		toSerialize["service_network_id"] = o.ServiceNetworkId
	}
	return toSerialize, nil
}

type NullableModelsSite struct {
	value *ModelsSite
	isSet bool
}

func (v NullableModelsSite) Get() *ModelsSite {
	return v.value
}

func (v *NullableModelsSite) Set(val *ModelsSite) {
	v.value = val
	v.isSet = true
}

func (v NullableModelsSite) IsSet() bool {
	return v.isSet
}

func (v *NullableModelsSite) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableModelsSite(val *ModelsSite) *NullableModelsSite {
	return &NullableModelsSite{value: val, isSet: true}
}

func (v NullableModelsSite) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableModelsSite) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
