/*
Nexodus API

This is the Nexodus API Server.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package client

import (
	"encoding/json"
)

// checks if the ModelsTunnelIP type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ModelsTunnelIP{}

// ModelsTunnelIP struct for ModelsTunnelIP
type ModelsTunnelIP struct {
	// IP address and port of the endpoint.
	Address *string `json:"address,omitempty"`
	// VPC CIDR this address was allocated from
	Cidr *string `json:"cidr,omitempty"`
}

// NewModelsTunnelIP instantiates a new ModelsTunnelIP object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewModelsTunnelIP() *ModelsTunnelIP {
	this := ModelsTunnelIP{}
	return &this
}

// NewModelsTunnelIPWithDefaults instantiates a new ModelsTunnelIP object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewModelsTunnelIPWithDefaults() *ModelsTunnelIP {
	this := ModelsTunnelIP{}
	return &this
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *ModelsTunnelIP) GetAddress() string {
	if o == nil || IsNil(o.Address) {
		var ret string
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsTunnelIP) GetAddressOk() (*string, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *ModelsTunnelIP) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given string and assigns it to the Address field.
func (o *ModelsTunnelIP) SetAddress(v string) {
	o.Address = &v
}

// GetCidr returns the Cidr field value if set, zero value otherwise.
func (o *ModelsTunnelIP) GetCidr() string {
	if o == nil || IsNil(o.Cidr) {
		var ret string
		return ret
	}
	return *o.Cidr
}

// GetCidrOk returns a tuple with the Cidr field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ModelsTunnelIP) GetCidrOk() (*string, bool) {
	if o == nil || IsNil(o.Cidr) {
		return nil, false
	}
	return o.Cidr, true
}

// HasCidr returns a boolean if a field has been set.
func (o *ModelsTunnelIP) HasCidr() bool {
	if o != nil && !IsNil(o.Cidr) {
		return true
	}

	return false
}

// SetCidr gets a reference to the given string and assigns it to the Cidr field.
func (o *ModelsTunnelIP) SetCidr(v string) {
	o.Cidr = &v
}

func (o ModelsTunnelIP) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ModelsTunnelIP) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.Cidr) {
		toSerialize["cidr"] = o.Cidr
	}
	return toSerialize, nil
}

type NullableModelsTunnelIP struct {
	value *ModelsTunnelIP
	isSet bool
}

func (v NullableModelsTunnelIP) Get() *ModelsTunnelIP {
	return v.value
}

func (v *NullableModelsTunnelIP) Set(val *ModelsTunnelIP) {
	v.value = val
	v.isSet = true
}

func (v NullableModelsTunnelIP) IsSet() bool {
	return v.isSet
}

func (v *NullableModelsTunnelIP) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableModelsTunnelIP(val *ModelsTunnelIP) *NullableModelsTunnelIP {
	return &NullableModelsTunnelIP{value: val, isSet: true}
}

func (v NullableModelsTunnelIP) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableModelsTunnelIP) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
